//DefaultCFG JASS plugin
//Copyright (C) 2010 Zlyden'
//http://jass.ucoz.net/
//
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//Created By:
//       Zlyden' <zlyden007@mail.ru>.

#include "version.h" //    
//   :
#include <jka/game/q_shared.h>
#include <jka/game/g_local.h>
#include <jassapi.h> //,  

pluginres_t* g_result = NULL;
//  
plugininfo_t g_plugininfo = {
	"DefaultCFG",					// 
	DefaultCFG_version,				//
	"Restores default server cfg when all the players leaving the server",				//
	DefaultCFG_Builder,				//
	"http://www.jass.ucoz.net/",	//
	0,								//    
	0,								//        
	0,								//        
	JASS_PIFV_MAJOR,				//  (  jassapi.h)
	JASS_PIFV_MINOR
};
eng_syscall_t g_syscall = NULL;
mod_vmMain_t g_vmMain = NULL;
pluginfuncs_t* g_pluginfuncs = NULL;

const int MAX_PLAYERS = 32;
bool players [ MAX_PLAYERS ] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
byte connections,i;
time_t starttime;

//  ,  
// pinfo -    g_plugininfo ( )
C_DLLEXPORT void JASS_Query(plugininfo_t** pinfo) {
	JASS_GIVE_PINFO();
}

// ,  
// ,    ,  
// engfunc -    syscall 
// modfunc -    vmMain 
// presult -     
// iscmd -  : 0 =    jass.ini, 1 =    "jass load"
C_DLLEXPORT int JASS_Attach(eng_syscall_t engfunc, mod_vmMain_t modfunc, pluginres_t* presult, pluginfuncs_t* pluginfuncs, int iscmd) {
	JASS_SAVE_VARS();
	g_syscall (G_CVAR_REGISTER,0,"sv_DefaultCFG","server.cfg",CVAR_ARCHIVE);
	iscmd = 0;
	time(&starttime);
	starttime+=2;
	return 1;
	//return 0; - 
}

//  ,  
// ,    ,  
// - iscmd  ; 0 =         "jass force_unload", 1 =   "jass unload"
C_DLLEXPORT void JASS_Detach(int iscmd) {
	iscmd = 0;
}

//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_SHUTDOWN,  
C_DLLEXPORT int JASS_vmMain(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {

	JASS_RET_IGNORED(1); //  
}

//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {

	//g_syscall(G_PRINT, JASS_VARARGS("syscall(%s)\n", JASS_ENGMSGNAME(cmd)));

	JASS_RET_IGNORED(1);
}

//      vmMain  (..  - )
// ,     ,
// ..  cmd==GAME_INIT,  
C_DLLEXPORT int JASS_vmMain_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11) {

	//  ( )
	if (cmd == GAME_CLIENT_CONNECT && !arg2) {
		players [ arg0 ] = true;
	}

	//        
	//         
	else if ( cmd==GAME_CLIENT_DISCONNECT && players[arg0] ){
		time_t ltime;
		time(&ltime);
		players [ arg0 ] = false;
		connections=0;
		for(i = 0; i<MAX_PLAYERS; ++i)
			connections+=players[i];
		if ( !connections && ltime>starttime ){
            char * temp=(char*)JASS_GETSTRCVAR("sv_DefaultCFG");
            if ( *temp )
                g_syscall( G_SEND_CONSOLE_COMMAND, EXEC_APPEND, JASS_VARARGS("exec %s\n",temp));
		}
	}
	JASS_RET_IGNORED(1);
}

//      syscall  (..  - )
C_DLLEXPORT int JASS_syscall_Post(int cmd, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6, int arg7, int arg8, int arg9, int arg10, int arg11, int arg12) {
	//g_syscall(G_PRINT, JASS_VARARGS("syscall_Post(%s)\n", JASS_ENGMSGNAME(cmd)));
	JASS_RET_IGNORED(1);
}
